"use strict";

PH.albumCache=(function(){ //functiuon returning an object
    //var that=this;
    //var picsInAlbum=picsAlbm;
    //this.pathStr=pathString;
    var picsInAlbum=[];
    var mediaShadow=[];
    var pathStr=null;
    var albumTitle,nrDisplayPictures;
    var cPicAlbumIndex=-1; //current pic index in album (valid: 0-picsInAlbum.length-1)
    var cPicCacheIndex=-1; //current pic index in cache array (valid: 0-imgCache.length-1)
    var loadingImg=null; //the currently loading img object
    var loadingShadow=null; //the currently loading mediaShadow element
    var widthOnEntry=-1;
    var showingImg=-1; //in the beginning there is no img showing
    var imgDiv=null; //=elm('imgdiv'); //caching this
    var showInfo=true;
    var spinner=null;
    var map=null,photoMarker=null,photomapDiv=null;
    var picWatchStartTime=null,thmbWatchStartTime=null;
    var direction=0; //1 if going forward, -1 if going backwords

    var KCacheRadius=2;

    var statusFlags={
        FlagThumbnailLoading:1,
        FlagThumbnailLoaded:2,
        FlagMediaLoading:4,
        FlagMediaLoaded:8,
        FlagMediaPrefetchSent:16
    };
    var spinnerOpts={
        lines: 11, // The number of lines to draw
        length: 5, // The length of each line
        width: 3, // The line thickness
        radius: 7, // The radius of the inner circle
        corners: 1, // Corner roundness (0..1)
        rotate: 0, // The rotation offset
        direction: 1, // 1: clockwise, -1: counterclockwise
        color: '#FFFFFF', // #rgb or #rrggbb or array of colors
        speed: 1, // Rounds per second
        trail: 60, // Afterglow percentage
        shadow: false, // Whether to render a shadow
        hwaccel: false, // Whether to use hardware acceleration
        className: 'spinner', // The CSS class to assign to the spinner
        zIndex: 2e9, // The z-index (defaults to 2000000000)
        top: '50%', // Top position relative to parent
        left: '50%' // Left position relative to parent
    };
    var _newElement=function(i){
        var p;
        console.assert(typeof(picsInAlbum[i].t)==='undefined');
        //create the div container
        p=document.createElement('div');
        p.id='media'+i;
        p.className='mediadiv';
        p.style.display='none';
        
        //create the elements inside the container
        if(picsInAlbum[i].fl&PH.server.albumFlags.FlagIsVideo){
            //this is a video element
            //p.innerHTML='<video id="videoelm" controls preload="metadata" class="fsvideo"><source type="video/mp4"/></video>';
        } else {
            //this is an image
            p.innerHTML='<img class="fsimg" src=""><img class="fsimg" src=""><div class="imginfo"></div>';
        }
        
        return p;
    };
    
    var _newShadowElement=function(i){
        var r={
            photostovisI:i,
            photostovisStatus:0,
            photostovisRot:''
        };
        return r;
    };
    
    var _getIdFromIndex=function(i){
        //return PH.path[PH.path.length-1].e[i].id;
        return picsInAlbum[i].id;
    };
    
    var _removeElement=function(i){
        //remove the DOM element(s). This function is important, otherwise memory leaks will kill the browser
        var p=imgDiv.children[i],r;
        console.log("_removeElement++: nr children of elm2remove="+p.children.length);
        //is this a video or image?
        if(p.children.length===3){
            //this is an image
            //thumb
            r=p.children[0];
            r.removeEventListener('load',_imageLoaded);
            r.style.cssText='';
            r.style.display='';
            r.style.transition='';
            r.style.top=null;
            r.style.left=null;
            //r.src='';
            //image
            r=p.children[1];
            if(loadingImg && loadingImg.src===r.src)
                loadingImg=null;
            r.removeEventListener('load',_imageLoaded);
            r.style.cssText='';
            r.style.display='';
            r.style.transition='';
            r.style.top=null;
            r.style.left=null;
            //r.src='';
            //infobox
            r=p.children[2];
            if(r.children.length)
                r.children[0].style.display=null;
            r.style.width=null;
            r.style.height=null;
            r.style.bottom=null;
            r.style.right=null;
            r.style.transition='';
            r.innerHTML='';
            //
            p.innerHTML='';
        } else if(p.children.length===1){
            //this is a video
            r=p.children[0];
            r.removeEventListener('loadedmetadata',_metadataLoaded);
            r.style.width=null;
            r.style.height=null;
            r.preload=null;
            //
            p.innerHTML='';
        } else
            console.assert(p.children.length===0);
        
        while(p.lastChild)
            p.removeChild(p.lastChild);
        
        imgDiv.removeChild(p);
        //remove the mediaShadow element
        mediaShadow.splice(i,1);
        console.assert(imgDiv.children.length===mediaShadow.length);
        console.log("_removeElement--");
    };
    
    var _getNextIndex=function(i){
        //console.log("_getNextIndex")
        var n=i+1;
        while(n<picsInAlbum.length){
            if(typeof(picsInAlbum[n].t)==='undefined')return n;//this is an image
            else n++;//this is an album that we skip
        }
        return -1; //not found
    };
    var _getPrevIndex=function(i){
        var p=i-1;
        while(p>=0){
            if(typeof(picsInAlbum[p].t)==='undefined')return p;//this is an image
            else p--;//this is an album that we skip
        }
        return -1; //not found
    };
    var _sizeImg=function(i,isThumb){
        console.assert(i>=0 && i<imgDiv.children.length);
        var imgWidth,imgHeight; //we cannot trust r.width and r.height because they are not rotated
        var rot,dw,hr,vr,r;
        var cssText='';
        var s=mediaShadow[i];
        var p=imgDiv.children[i];
        var photostovisWidth,photostovisHeight,photostovisTop,photostovisTop0,photostovisLeft,photostovisLeft0;
        var albumElm=picsInAlbum[s.photostovisI];
        if(isThumb)r=p.children[0];
        else r=p.children[1];

        console.log("");
        console.groupCollapsed("sizeImg with photostovisI="+s.photostovisI);
        console.assert(r.height>0 && r.width>0,"r.height="+r.height+", r.width="+r.width);
        rot=albumElm.rot;
        console.assert(typeof(albumElm.w)==='number' && typeof(albumElm.h)==='number');
        

        if(rot===90 || rot===270){
            //switch width and height
            console.log("Switching width and height ...");
            imgWidth=albumElm.h;
            imgHeight=albumElm.w;
        } else {
            imgWidth=albumElm.w;
            imgHeight=albumElm.h;
        }
        //moved here from below, see comments
        if(s.photostovisRot.length)
            cssText+=PH.platform.transformPrefix+'transform:'+s.photostovisRot+'; ';
        else rot=0;
        /*
        else {
            rot=0;
            console.log("Rotation forced to zero because photostovisRot is null");
        }

        if(rot===90 || rot===270){
            //switch width and height
            console.log("Switching width and height ...");
            imgWidth=r.naturalHeight>0?r.naturalHeight:r.height;
            imgHeight=r.naturalWidth>0?r.naturalWidth:r.width;
        } else {
            imgWidth=r.naturalWidth>0?r.naturalWidth:r.width;
            imgHeight=r.naturalHeight>0?r.naturalHeight:r.height;
        }*/
        
        

        //it is possible that the if(...)rot=0 line must be here below for ios6 and above for ios7. To be checked with an ios6 at some point
        //if(s.photostovisRot==='')rot=0;

        dw=document.documentElement.clientWidth;
        hr=dw/imgWidth;
        vr=document.documentElement.clientHeight/imgHeight;
        console.log("Image Width="+imgWidth+" Image Height="+imgHeight);
        console.log("Document Width="+document.documentElement.clientWidth+" Document Height="+document.documentElement.clientHeight);
        console.log("Horizontal ratio="+hr+" Vertical ratio="+vr);
        
        //console.log("JSON width="+albumElm.w+", JSON height="+albumElm.h);
        
        if(hr<vr){
            if(rot===90 || rot===270){
                //switch width and height
                photostovisWidth=imgHeight*hr;
                photostovisLeft=(document.documentElement.clientWidth-photostovisWidth)/2;
                photostovisHeight=dw;
                photostovisTop=(document.documentElement.clientHeight-photostovisWidth)/2;
                photostovisTop0=(photostovisWidth-photostovisHeight)/2;
                //if the black lateral margins are wider than 360+5 pixels, do NOT move the picture to the left
                /*
                if(photostovisLeft>=365)
                    photostovisLeft0=photostovisLeft;
                else*/
                    photostovisLeft0=(photostovisHeight-photostovisWidth)/2;
            } else {
                photostovisWidth=dw;
                photostovisLeft=(document.documentElement.clientWidth-photostovisWidth)/2;
                photostovisHeight=imgHeight*hr;
                photostovisTop=(document.documentElement.clientHeight-photostovisHeight)/2;
                photostovisTop0=0;
                //if the black lateral margins are wider than 360+5 pixels, do NOT move the picture to the left
                /*if(photostovisLeft>=365)
                    photostovisLeft0=photostovisLeft;
                else*/
                    photostovisLeft0=0;
            }
            
            console.log("Full width. Scaled height="+photostovisHeight+" Distance to top="+photostovisTop);
        } else {
            if(rot===90 || rot===270){
                //switch width and height
                photostovisWidth=document.documentElement.clientHeight;
                photostovisLeft=(document.documentElement.clientWidth-photostovisWidth)/2;
                photostovisHeight=imgWidth*vr;
                photostovisTop0=photostovisTop=(photostovisWidth-photostovisHeight)/2;
                //if the black lateral margins are wider than 360+5 pixels, do NOT move the picture to the left
                if((document.documentElement.clientWidth-imgWidth*vr)/2>=365)
                    photostovisLeft0=photostovisLeft;
                else
                    photostovisLeft0=(photostovisHeight-photostovisWidth)/2;
            } else {
                photostovisWidth=imgWidth*vr;
                photostovisLeft=(document.documentElement.clientWidth-photostovisWidth)/2;
                photostovisHeight=document.documentElement.clientHeight;
                photostovisTop0=photostovisTop=0;
                //if the black lateral margins are wider than 360+5 pixels, do NOT move the picture to the left
                if(photostovisLeft>=365)
                    photostovisLeft0=photostovisLeft;
                else
                    photostovisLeft0=0;
            }
            
            console.log("Full height. Scaled width="+photostovisWidth+" Distance to left="+photostovisLeft);
        }

        //new stuff: create the cssText
        if(showInfo)
            cssText+='width:'+photostovisWidth+'px; height:'+photostovisHeight+
                'px; top:'+photostovisTop0+'px; left:'+photostovisLeft0+'px;';
        else
            cssText+='width:'+photostovisWidth+'px; height:'+photostovisHeight+
                'px; top:'+photostovisTop+'px; left:'+photostovisLeft+'px;';
        r.style.cssText=cssText;
        
        if(isThumb){
            s.photostovisThmWidth=photostovisWidth;
            s.photostovisThmHeight=photostovisHeight;
            s.photostovisThmLeft=photostovisLeft;
            s.photostovisThmLeft0=photostovisLeft0;
            s.photostovisThmTop=photostovisTop;
            s.photostovisThmTop0=photostovisTop0;
        } else {
            s.photostovisImgWidth=photostovisWidth;
            s.photostovisImgHeight=photostovisHeight;
            s.photostovisImgLeft=photostovisLeft;
            s.photostovisImgLeft0=photostovisLeft0;
            s.photostovisImgTop=photostovisTop;
            s.photostovisImgTop0=photostovisTop0;
        }

        console.groupEnd();
    };
    
    var _imageLoaded=function(){
        var p=this.parentNode,s;
        var camera,txt,c,mp,mb,infobox;
        var i,index=-1;
        var sc_num,sc_denom;
        var picLoadTime;
        //find our loaded media element among imgDiv children
        for(i=0;i<imgDiv.children.length;i++)
            if(imgDiv.children[i]===p){
                //we found it!
                index=i;
                break;
            }
        if(index<0){
            console.warn("Stray image loaded. Ignoring.");
            return;
        }
        s=mediaShadow[index];

        console.log("Img loaded: "+s.photostovisI+" src="+this.src);

        //rotate the picture if needed. Rotating yelds correct width and height
        if(PH.platform.name==='ios'){
            //on ios the browser will rotate the picture by itself, based on the metadata, so we should NOT rotate it
            s.photostovisRot='';
            if(picsInAlbum[s.photostovisI].rot)
                console.log("This picture would have been rotated, but we are on iOS.");
        } else if(picsInAlbum[s.photostovisI].rot){
            s.photostovisRot='rotate('+picsInAlbum[s.photostovisI].rot+'deg)';
            console.log("Rotating loaded picture: "+s.photostovisRot);
        }
        //mark image as loaded, resize it
        if(s.photostovisStatus&statusFlags.FlagThumbnailLoading){
            s.photostovisStatus+=statusFlags.FlagThumbnailLoaded-statusFlags.FlagThumbnailLoading;
            _sizeImg(index,true);
        } else {
            console.assert(loadingImg.src===this.src);
            console.assert(loadingShadow.photostovisLoadStartTime===s.photostovisLoadStartTime);
            console.assert(typeof(s.photostovisLoadStartTime)==='number',s.photostovisLoadStartTime);
            picLoadTime=Date.now()-s.photostovisLoadStartTime;
            console.log("Picture ("+s.photostovisID+") loaded in "+picLoadTime+"ms. startTime="+s.photostovisLoadStartTime);
            PH.sendWebsocketMessage("loadID="+s.photostovisID+" loadTime="+picLoadTime);
            delete s.photostovisLoadStartTime;
            loadingImg=null;
            loadingShadow=null;
            console.assert(s.photostovisStatus&statusFlags.FlagMediaLoading);
            s.photostovisStatus+=statusFlags.FlagMediaLoaded-statusFlags.FlagMediaLoading;
            _sizeImg(index,false);
        }


        if(s.photostovisPathStr===pathStr){
            if(s.photostovisI===cPicAlbumIndex){
                //show picture
                console.log("Current picture has been loaded, showing it!");
                PH.albumCache.showImg(index,PH.albumCache.loadNextMedia);
            } else //load next picture
                setTimeout(PH.albumCache.loadNextMedia,0);
        }
        delete s.photostovisPathStr;

        //image metadata
        c=picsInAlbum[s.photostovisI];
        if(typeof(c.m)==='number' && c.m!==0xFFFF){
            camera=PH.server.metadata.m[c.m];
            console.assert(typeof(camera.c)==='string' && camera.c.length>=0);
        } else camera=null;
        console.log("Picture data:");
        console.log(c);
        console.log("CAMERA:");
        console.log(camera);

        //write the picinfo icon
        infobox=p.children[2];
        if(showInfo){
            //txt='<img class="picinfo" src="ct/picinfo.svg" style="display:none">';
            txt='<svg viewBox="0 0 350 350" class="picinfo" style="display:none"><use xlink:href="#picinfo-svg"></use></svg>'
            infobox.style.width=null;
            infobox.style.height=null;
            s.photostovisInfoboxShown=true;
        } else {
            //txt='<img class="picinfo" src="ct/picinfo.svg">';
            txt='<svg viewBox="0 0 350 350" class="picinfo"><use xlink:href="#picinfo-svg"></use></svg>'
            infobox.style.width="34px";
            infobox.style.height="34px";
            s.photostovisInfoboxShown=false;
        }

        //album title row
        txt+='<h4>'+albumTitle+' ('+(c.displayNr)+'/'+nrDisplayPictures+')</h4>';
        //title row
        txt+='<h1>'+c.fn+'</h1>';
        //date row
        if(c.c!==0x7FFFFFFF)
            txt+='<h2>'+PH.getFormattedDateTime(c.c)+'</h2>';
        
        //Original image data
        if(c.sz<1048576)mb=(c.sz/1024).toFixed(0)+' KB';
        else mb=(c.sz/1048576).toFixed(1)+' MB';
        console.assert(c.w>0 && c.h>0,"c.w="+c.w+", c.h="+c.h);
        mp=c.w*c.h/1000000;
        mp=mp.toFixed(1)+' Mpix';

        txt+='<table><tr><td>Original:</td><td class="right">'+c.w+'</td><td>x</td><td>'+c.h+'</td><td class="right">('+mp+
                '</td><td>/</td><td>'+mb+')</td></tr>';
        
        //transfered image data
        console.assert(this.width>0 && this.height>0);
	    if(typeof(this.naturalWidth)!=='undefined'){
            if(this.naturalWidth===c.w && this.naturalHeight===c.h){
		        txt+='<tr><td>On screen:</td><td colspan="6" class="originalimg">original image</td></tr>';
                sc_num=0;
            } else {
                //mp=(c.w/this.naturalWidth)*(c.h/this.naturalHeight);
                sc_num=Math.round(this.naturalWidth*8/c.w);
                console.assert(sc_num>0 && sc_num<8);
			}
		} else {
            if(this.width===c.w && this.height===c.h){
		        txt+='<tr><td>On screen:</td><td colspan="6" class="originalimg">original image</td></tr>';
                sc_num=0;
            } else {
                //mp=(c.w/this.width)*(c.h/this.height);
                sc_num=Math.round(this.width*8/c.w);
                console.assert(sc_num>0 && sc_num<8);
			}
		}
        if(sc_num>0){
            if(sc_num===4){
                sc_num=1;sc_denom=2;
            } else if(sc_num===2 || sc_num===6){
                sc_num/=2;sc_denom=4;
            } else sc_denom=8;
            mp=sc_num+'/'+sc_denom;
            txt+='<tr><td>On screen:</td><td class="right">'+this.naturalWidth+'</td><td>x</td><td>'+this.naturalHeight+
                '</td><td colspan="3" class="center">('+mp+'x'+mp+' from original)</td></tr>';
        }
            

        txt+='</table>';
        //Camera & nr pictures
        if(camera)
            txt+='<h2>Camera: '+camera.c+'</h2><h3>('+camera.p+' pictures taken with this camera)</h3>';

        txt+='<table>';
        //Focal length
        if(c.fln)
            txt+='<tr><td class="nowrap">Focal length:</td><td>'+c.fln.toFixed(2)+'mm</td></tr>';
        //Focal length in 35mm
        if(c.fl35)
            txt+='<tr><td class="nowrap">35mm equivalent:</td><td>'+c.fl35+'mm</td></tr>';
        //Exposure
        if(c.et)
            txt+='<tr><td class="nowrap">Exposure time:</td><td>'+c.et.toPrecision()+'s</td></tr>';
        //Exposure program
        if(c.ep)
            txt+='<tr><td class="nowrap">Exposure program:</td><td>'+PH.getExposureProgram(c.ep)+'</td></tr>';
        //F number
        if(c.fnr)
            txt+='<tr><td class="nowrap">F Number:</td><td>f/'+c.fnr.toPrecision()+'</td></tr>';
        //ISO
        if(c.iso)
            txt+='<tr><td class="nowrap">ISO:</td><td>'+c.iso+'</td></tr>';
        //Zoom
        if(c.fl35>0)
            txt+='<tr><td class="nowrap">Zoom (35mm equiv):</td><td>'+(c.fl35/50).toFixed(1)+'</td></tr>';
        else if(c.fln>0 && camera && camera.mfl>0 && camera.p>=100) {
            //we only do this for more than 100 pictures, to increase the probability that at least one of these 
            //has the minimum focus length of the camera
            txt+='<tr><td class="nowrap">Zoom (approx.):</td><td>'+(c.fln/camera.mfl).toFixed(1)+'</td></tr>';
        }
        txt+='</table>';

        //map
        if(typeof(c.lat)!=='undefined'){
            console.assert(typeof(c.lng)!=='undefined');
            //pseudo element in infobox
            txt+='<div class="pseudomap"></div>';
        };
        
        //done, write the text
        infobox.innerHTML=txt;
    };
    
    var _metadataLoaded=function(){
        var p=this.parentNode,s;
        var i,index=-1;
        //find our loaded media element among imgDiv children
        for(i=0;i<imgDiv.children.length;i++)
            if(imgDiv.children[i]===p){
                //we found it!
                index=i;
                break;
            }
        if(index<0){
            console.warn("Stray video metadata loaded. Ignoring.");
            return;
        }
        s=mediaShadow[index];
        console.log("Video Metadata loaded: "+s.photostovisI+". Video dimensions: "+this.videoWidth+"x"+this.videoHeight);
        console.log("Seekable: "+this.seekable+", readyState: "+this.readyState);
        console.log(s);
        //mark video as loaded
        console.assert(s.photostovisStatus&statusFlags.FlagMediaLoading);
        s.photostovisStatus+=statusFlags.FlagMediaLoaded-statusFlags.FlagMediaLoading;
        //size the video
        if(this.videoWidth/this.videoHeight>PH.platform.screenWidth/PH.platform.screenHeight){
            //the video is wider than the screen.
            this.style.width='100%';
            this.style.height='auto';
        } else {
            //the screen is wider than the video.
            this.style.height='100%';
            this.style.width='auto';
        }
        //show or load next (or both)
        if(s.photostovisPathStr===pathStr){
            if(s.photostovisI===cPicAlbumIndex){
                //show video
                console.log("Current video has been loaded, showing it!");
                PH.albumCache.showVideo(index,PH.albumCache.loadNextMedia);
            } else //load next picture
                setTimeout(PH.albumCache.loadNextMedia,0);
        }
        delete s.photostovisPathStr;
        //mark the shadow as having a "stopable" child
        s.photostovisStopable=0;
    };
    
    var _showSpinner=function(){
        if(spinner)spinner.stop();
        spinner=null;
        spinner=new Spinner(spinnerOpts).spin(elm('fsimg-spinner-box'));
    };
    var _hideSpinner=function(){
        if(spinner)spinner.stop();
        spinner=null;
    };
    var _hideShowing=function(){
        if(showingImg<0)return;
        
        var rOld=imgDiv.children[showingImg];
        var sOld=mediaShadow[showingImg];
        rOld.style.display='none';
        if(typeof(sOld.photostovisStopable)==='number' && rOld.children[sOld.photostovisStopable])
            rOld.children[sOld.photostovisStopable].pause();
        showingImg=-1;
    };

    return {
        setShowInfo:function(storedShowInfo){
            showInfo=storedShowInfo;
        },
        getShowInfo:function(){
            return showInfo;
        },
        clear:function(){
            picsInAlbum=null;
            pathStr=null;
            albumTitle=null;
            nrDisplayPictures=0;
            cPicAlbumIndex=-1; //current pic index in album (valid: 0-picsInAlbum.length-1)
            cPicCacheIndex=-1; //current pic index in cache array (valid: 0-imgCache.length-1)
            loadingImg=null;
            loadingShadow=null;
            showingImg=-1; //in the beginning there is no img showing
            direction=0;
            //clear imgDiv & media Shadow
            if(imgDiv)imgDiv.innerHTML='';
            mediaShadow=[];
        },
        init:function(picsAlbm,pathString,tt,nrdsp){
            picsInAlbum=picsAlbm;
            pathStr=pathString;
            albumTitle=tt;
            nrDisplayPictures=nrdsp;
            //console.log(picsInAlbum);
            console.assert(typeof(picsInAlbum)==='object');
            console.assert(Array.isArray(picsInAlbum));
            console.assert(typeof(pathStr)==='string' && pathStr.search('/t/')!==-1);
            cPicAlbumIndex=-1; //current pic index in album (valid: 0-picsInAlbum.length-1)
            cPicCacheIndex=-1; //current pic index in cache array (valid: 0-imgCache.length-1)
            loadingImg=null;
            loadingShadow=null;
            showingImg=-1; //in the beginning there is no img showing
            direction=0;
            if(!imgDiv)imgDiv=elm('imgdiv');
            //reset timings
            picWatchStartTime=thmbWatchStartTime=null;
            //clear imgDiv & media Shadow
            imgDiv.innerHTML='';
            mediaShadow=[];
            if(!photomapDiv)photomapDiv=elm('photomap');
        },
        resize:function(){
            if(!imgDiv)return;
            console.log("resize++");
            var s;
            var j;
            console.assert(imgDiv.children.length===mediaShadow.length);
            for(j=0;j<mediaShadow.length;j++){
                s=mediaShadow[j];
                s.photostovisThmHeight=-1;
                s.photostovisThmWidth=-1;
                s.photostovisImgHeight=-1;
                s.photostovisImgWidth=-1;
            }
            if(showingImg>=0 && cPicAlbumIndex>=0)
                if(!(picsInAlbum[cPicAlbumIndex].fl&PH.server.albumFlags.FlagIsVideo))
                    this.showImg(showingImg,null);
            if(spinner){
                spinner.stop();
                spinner=null;
                spinner=new Spinner(spinnerOpts).spin(elm('fsimg-spinner-box'));
            }
            console.log("resize--");
        },
        loadNextMedia:function(){
            var i=0,index=-1;
            var r,r2,s,media2load,shadow2load;
            var img2load;
            var albumIndexNext,albumIndexPrev;
            var query;
            var doPrefetching=false;
            
            console.groupCollapsed("loadNextMedia: current="+cPicAlbumIndex);
            console.assert(cPicAlbumIndex<picsInAlbum.length,"Current pic outside range: "+cPicAlbumIndex);
            console.assert(cPicCacheIndex>=0 && cPicCacheIndex<KCacheRadius+1+KCacheRadius,"cPicCacheIndex outside range");
            if(cPicAlbumIndex<0){
                console.log("returning (the user has exited the \"show pictures\" mode");
                console.groupEnd();
                return;
            } //the user has exited the "show pictures" mode

            r=imgDiv.children[cPicCacheIndex];
            s=mediaShadow[cPicCacheIndex];
            if(s.photostovisStatus&statusFlags.FlagMediaLoading || s.photostovisStatus&statusFlags.FlagThumbnailLoading){
                //current thumb already loading, we will continue when this is ready
                console.log("loadNextMedia: current thumb or media already loading, will continue with cache loading when it is loaded");
                if(picsInAlbum[cPicAlbumIndex].fl&PH.server.albumFlags.FlagIsVideo){
                    //we show the video even if it is not fully loaded
                    PH.albumCache.showVideo(cPicCacheIndex);
                    console.log("Showing current video");
                }
                console.groupEnd();
                return;
            }
            r2=picsInAlbum[cPicAlbumIndex];
            
            if(s.photostovisStatus&statusFlags.FlagThumbnailLoaded || !(r2.fl&PH.server.albumFlags.FlagHasThumbnail)){
                //current thumb loaded (or not available), check the current image

                //BUT FIRST: do we have an already loading image? If yes, we should wait until it loads (because we cannot cancel it)
                if(loadingImg){
                    //yes, we have a loading image
                    console.log("!!! We already have a loading image! Wait until it loads.");
                    console.groupEnd();
                    return;
                }

                if(s.photostovisStatus&statusFlags.FlagMediaLoaded){
                    //current image already loaded, we need a new image to load
                    //check first if all thumbnails are loaded
                    albumIndexNext=albumIndexPrev=cPicAlbumIndex;
                    for(i=1;i<KCacheRadius+1;i++){
                        index=cPicCacheIndex+i;
                        albumIndexNext=_getNextIndex(albumIndexNext);
                        if(index<imgDiv.children.length && albumIndexNext!==-1 && 
                                picsInAlbum[albumIndexNext].fl&PH.server.albumFlags.FlagHasThumbnail){
                            media2load=imgDiv.children[index];
                            shadow2load=mediaShadow[index];
                            if(!(shadow2load.photostovisStatus&statusFlags.FlagThumbnailLoaded))break;
                        }

                        index=cPicCacheIndex-i;
                        albumIndexPrev=_getPrevIndex(albumIndexPrev);
                        if(index>=0 && albumIndexPrev!==-1 && 
                                picsInAlbum[albumIndexPrev].fl&PH.server.albumFlags.FlagHasThumbnail){
                            media2load=imgDiv.children[index];
                            shadow2load=mediaShadow[index];
                            if(!(shadow2load.photostovisStatus&statusFlags.FlagThumbnailLoaded))break;
                        }
                    }//for
                    if(i<KCacheRadius+1){
                        console.log("Loading a thumb (index="+index+", current="+cPicCacheIndex+")");
                        shadow2load.photostovisStatus|=statusFlags.FlagThumbnailLoading;
                    } else {
                        //try with an image
                        albumIndexNext=albumIndexPrev=cPicAlbumIndex;
                        for(i=1;i<KCacheRadius+1;i++){
                            //following if prevents videos to be loaded, if they are more than one step after or before the current element
                            albumIndexNext=_getNextIndex(albumIndexNext);
                            albumIndexPrev=_getPrevIndex(albumIndexPrev);
                            if(i===1 || 
                                !(albumIndexNext!==-1 && picsInAlbum[albumIndexNext].fl&PH.server.albumFlags.FlagIsVideo)
                                || !(albumIndexPrev!==-1 && picsInAlbum[albumIndexPrev].fl&PH.server.albumFlags.FlagIsVideo)){
                                index=cPicCacheIndex+i;
                                if(index<imgDiv.children.length){
                                    media2load=imgDiv.children[index];
                                    shadow2load=mediaShadow[index];
                                    if(!(shadow2load.photostovisStatus&statusFlags.FlagMediaLoaded))break;
                                }

                                index=cPicCacheIndex-i;
                                if(index>=0){
                                    media2load=imgDiv.children[index];
                                    shadow2load=mediaShadow[index];
                                    if(!(shadow2load.photostovisStatus&statusFlags.FlagMediaLoaded))break;
                                }
                            }// if (after for)
                        }//for
                        if(i<KCacheRadius+1){
                            console.log("Loading an image/video (not a thumbnail)");
                            shadow2load.photostovisStatus|=statusFlags.FlagMediaLoading;
                        } else {
                            //nothing to load
                            console.log("loadNextMedia: ALL IMAGES IN CACHE LOADED!");
                            //based on our direction prefetch an image
                            if(direction===1){
                                //going forward.
                                albumIndexNext=_getNextIndex(albumIndexNext);
                                if(albumIndexNext!==-1 && !(picsInAlbum[albumIndexNext].fl&PH.server.albumFlags.FlagIsVideo)){
                                    console.log("PREFETCHING image ID="+picsInAlbum[albumIndexNext].id+", priority="+(KCacheRadius+1));
                                    PH.sendWebsocketMessage("prefetchID="+picsInAlbum[albumIndexNext].id+" priority="+(KCacheRadius+1));
                                }
                            } else if(direction===-1){
                                //going backward.
                                albumIndexPrev=_getPrevIndex(albumIndexPrev);
                                if(albumIndexPrev!==-1 && !(picsInAlbum[albumIndexPrev].fl&PH.server.albumFlags.FlagIsVideo)){
                                    console.log("PREFETCHING image ID="+picsInAlbum[albumIndexPrev].id+", priority="+(KCacheRadius+1));
                                    PH.sendWebsocketMessage("prefetchID="+picsInAlbum[albumIndexPrev].id+" priority="+(KCacheRadius+1));
                                }
                            } else console.assert(direction===0);

                            console.groupEnd();
                            return;
                        }
                    }
                } else {
                    console.log("Loading the current media");
                    index=cPicCacheIndex;
                    media2load=imgDiv.children[index];
                    shadow2load=mediaShadow[index];
                    shadow2load.photostovisStatus|=statusFlags.FlagMediaLoading;
                }
            } else {
                console.log("Loading the current thumbnail");
                index=cPicCacheIndex;
                media2load=imgDiv.children[index];
                shadow2load=mediaShadow[index];
                shadow2load.photostovisStatus|=statusFlags.FlagThumbnailLoading;
            }

            //load the current media
            shadow2load.photostovisPathStr=pathStr; //this is used to check if we have the same album
            shadow2load.photostovisID=_getIdFromIndex(shadow2load.photostovisI);
            console.log("loadNextMedia: loading thumb/media with id="+shadow2load.photostovisID+", i="+shadow2load.photostovisI+" and index="+index);
            if(picsInAlbum[shadow2load.photostovisI].fl&PH.server.albumFlags.FlagIsVideo){
                //loading the video
                console.log("Loading video: ");
                console.log(shadow2load);
                console.assert(shadow2load.photostovisStatus&statusFlags.FlagMediaLoading);

                media2load.innerHTML='<video controls class="fsvideo"><source src="'+
                        pathStr.replace('t','v')+shadow2load.photostovisID+(PH.server.key?'?key='+PH.server.key:'')+'"></video>';
                img2load=media2load.children[0];
                console.log("Video media state: "+img2load.readyState);
                //if(img2load.readyState)
                img2load.addEventListener('loadedmetadata',_metadataLoaded);
                img2load.preload='metadata';
                console.log("Metadata will be loaded for video with photostovisI: "+shadow2load.photostovisI);
            } else {
                //loading an image
                if(shadow2load.photostovisStatus&statusFlags.FlagMediaLoading)img2load=media2load.children[1];
                else if(shadow2load.photostovisStatus&statusFlags.FlagThumbnailLoading)img2load=media2load.children[0];
                else console.assert(0);
                
                img2load.addEventListener('load',_imageLoaded);
                 
                if(shadow2load.photostovisStatus&statusFlags.FlagMediaLoading){
                    img2load.src=pathStr.replace('t','i')+shadow2load.photostovisID+'?w='+PH.platform.screenWidth+'&h='+PH.platform.screenHeight+
                            (PH.server.key?'&key='+PH.server.key:'');
                    console.assert(typeof(shadow2load.photostovisLoadStartTime)==='undefined');
                    shadow2load.photostovisLoadStartTime=Date.now();
                    console.log("Starting loading picture ("+shadow2load.photostovisID+") at "+shadow2load.photostovisLoadStartTime);
                    loadingImg=img2load;
                    loadingShadow=shadow2load;
                    doPrefetching=true; //this will make the prefetch code below to run
                }else {
                    query=PH.platform.pixelRatioTxt;
                    if(PH.server.key)query+='&key='+PH.server.key;
                    if(query.length>0 && query.charAt(0)!=='?')
                        query='?'+query.slice(1);
                    
                    img2load.src=pathStr+shadow2load.photostovisID+query;
                }
            }

            if(doPrefetching){
                //prefetching next image
                albumIndexNext=albumIndexPrev=cPicAlbumIndex;
                shadow2load=null; //not really necessary
                for(i=1;i<KCacheRadius+1;i++){
                    //following if prevents videos to be loaded
                    albumIndexNext=_getNextIndex(albumIndexNext);
                    albumIndexPrev=_getPrevIndex(albumIndexPrev);
                    if(!(albumIndexNext!==-1 && picsInAlbum[albumIndexNext].fl&PH.server.albumFlags.FlagIsVideo) ||
                       !(albumIndexPrev!==-1 && picsInAlbum[albumIndexPrev].fl&PH.server.albumFlags.FlagIsVideo)){
                        index=cPicCacheIndex+i;
                        if(index<imgDiv.children.length){
                            shadow2load=mediaShadow[index];
                            if(!(shadow2load.photostovisStatus&statusFlags.FlagMediaLoaded) &&
                               !(shadow2load.photostovisStatus&statusFlags.FlagMediaLoading) &&
                               !(shadow2load.photostovisStatus&statusFlags.FlagMediaPrefetchSent))break;
                        }

                        index=cPicCacheIndex-i;
                        if(index>=0){
                            shadow2load=mediaShadow[index];
                            if(!(shadow2load.photostovisStatus&statusFlags.FlagMediaLoaded) &&
                               !(shadow2load.photostovisStatus&statusFlags.FlagMediaLoading) &&
                               !(shadow2load.photostovisStatus&statusFlags.FlagMediaPrefetchSent))break;
                        }
                    }// if (after for)
                }//for
                if(i<KCacheRadius+1){
                    shadow2load.photostovisStatus|=statusFlags.FlagMediaPrefetchSent;
                    if(typeof(shadow2load.photostovisID)!=='string')
                        shadow2load.photostovisID=_getIdFromIndex(shadow2load.photostovisI);
                    console.log("PREFETCHING image ID="+shadow2load.photostovisID+", priority="+i);
                    PH.sendWebsocketMessage("prefetchID="+shadow2load.photostovisID+" priority="+i);
                } else //nothing to prefetch
                    console.log("No image needs prefetching.");
            }//if(!prefetchPriority)

            console.groupEnd();
        },//loadNextMedia
        displayMedia:function(i){
            var j,ii;
            var r,s,targetLength;

            console.assert(i>=0 && i<picsInAlbum.length,"i outside range: "+i);
            console.assert(imgDiv.children.length<=KCacheRadius+1+KCacheRadius,"imgDiv.children.length is not less than "+
                           (KCacheRadius+1+KCacheRadius)+" but "+imgDiv.children.length);
            console.assert(typeof(picsInAlbum[i].t)==='undefined',"displayMedia: element is not picture!");
            console.assert(imgDiv.children.length===mediaShadow.length);
            console.log(" ");
            console.log("displayMedia++: current="+i);
            PH.inPictureMode=true;
            
            if(widthOnEntry<0)
                widthOnEntry=document.body.clientWidth;

            //set cPicXXXIndex
            cPicAlbumIndex=i;
            cPicCacheIndex=-1; //we do not know it yet

            //find our element among the divs, if any
            for(j=0;j<mediaShadow.length;j++)
                if(mediaShadow[j].photostovisI===i){
                    cPicCacheIndex=j;
                    break;
                }
            if(cPicCacheIndex>=0){
                //remove too "small" elements from the front of the img array
                while(cPicCacheIndex>KCacheRadius){
                    //remove the media element
                    _removeElement(0);
                    //done with removing
                    if(showingImg>=0)showingImg--;
                    cPicCacheIndex--;
                }
                //remove all elements that are too "big"
                for(j=cPicCacheIndex+KCacheRadius+1;j<imgDiv.children.length;j++){
                    _removeElement(cPicCacheIndex+KCacheRadius+1);
                }
            } else {
                //array should be "empty", set the current element as the first and nullify the rest
                imgDiv.innerHTML=null;//this should remove all children
                mediaShadow=[];
                console.assert(imgDiv.children.length===0);
                console.log("adding first element");
                imgDiv.appendChild(_newElement(i));
                mediaShadow.push(_newShadowElement(i));
                cPicCacheIndex=0;
            }
            console.assert(cPicCacheIndex>=0,"cPicCacheIndex is not >=0 but "+cPicCacheIndex);

            //adding elements in front
            while(cPicCacheIndex<KCacheRadius){
                //get the element index
                ii=_getPrevIndex(mediaShadow[0].photostovisI);
                if(ii<0)break; //we do not have a prev element

                imgDiv.insertBefore(_newElement(ii),imgDiv.children[0]);
                mediaShadow.unshift(_newShadowElement(ii));

                console.log("#### displayMedia: added to cache before current: "+ii);
                cPicCacheIndex++;
                if(showingImg>=0)showingImg++;
                console.log("Showing img: "+showingImg);
            }

            //change the elements after the current element
            console.assert(imgDiv.children.length-cPicCacheIndex<=KCacheRadius+1,"imgDiv.children.length="+imgDiv.children.length+", cPicCacheIndex="+cPicCacheIndex);
            targetLength=cPicCacheIndex+KCacheRadius+1; //KCacheRadius more elements after the current element (KCacheRadius+1, 1 is for current element)
            for(j=imgDiv.children.length;j<targetLength;j++){
                ii=_getNextIndex(mediaShadow[j-1].photostovisI);
                if(ii<0)break; //we do not have a next element
                imgDiv.appendChild(_newElement(ii));
                mediaShadow.push(_newShadowElement(ii));
                console.log("#### displayMedia: added to cache after current: "+ii);
            }
            console.assert(imgDiv.children.length<=KCacheRadius+1+KCacheRadius,imgDiv.children.length);
            console.assert(imgDiv.children.length===mediaShadow.length);

            //check if the IDs are in order AND remove video elements for elements that are too far
            for(j=0;j<imgDiv.children.length;j++){
                r=imgDiv.children[j];
                s=mediaShadow[j];
                console.assert(s.photostovisI>=0);
                if(j>0)
                    console.assert(mediaShadow[j-1].photostovisI<s.photostovisI,"not consecutive");
                //is the current element a video elelemt?
                if((picsInAlbum[s.photostovisI].fl&PH.server.albumFlags.FlagIsVideo) && 
                        !(j-cPicCacheIndex<=1 && j-cPicCacheIndex>=-1)){
                    r.innerHTML=null;
                    s.photostovisStatus=0;
                }
                        
            }
            console.log("Current showingImg="+showingImg+", current picture index="+cPicCacheIndex);

            //check first the status of the current element
            if(picsInAlbum[cPicAlbumIndex].fl&PH.server.albumFlags.FlagIsVideo)
                this.showVideo(cPicCacheIndex,this.loadNextMedia);
            else
                this.showImg(cPicCacheIndex,this.loadNextMedia); 

            console.log("displayMedia--");
        },
        showImg:function(i,callback){
            console.assert(i>=0);
            console.assert(i===cPicCacheIndex);
            var r,p,s,rOther,infobox,c;
            var mapOptions,photoPos;
            
            p=imgDiv.children[i];
            s=mediaShadow[i];
            //check if we have something to show
            if(!(s.photostovisStatus&statusFlags.FlagThumbnailLoaded || s.photostovisStatus&statusFlags.FlagMediaLoaded)){
                //nothing to show, we should return.
                console.log("showImg: nothing to show, returning.");
                //but first, call the callback, if any
                if(callback)
                    setTimeout(callback,0);
                return;
            }
            console.assert(cPicCacheIndex>=0);
            
            //find out r
            if(s.photostovisStatus&statusFlags.FlagMediaLoaded){
                r=p.children[1];
                rOther=p.children[0];
                //we need this here because the screen size might have been changed since the picture was loaded, and a resize was triggered
                if(s.photostovisImgHeight<=0 || s.photostovisImgWidth<=0){
                    console.log("Looks like we need to resize. s: ("+s.photostovisImgHeight+" "+s.photostovisImgWidth+")");
                    console.log(s);
                    _sizeImg(i,false);
                    console.log("Resize done: s: ("+s.photostovisImgHeight+" "+s.photostovisImgWidth+")");
                }
            } else {
                r=p.children[0];
                rOther=p.children[1];
                //we need this here because the screen size might have been changed since the picture was loaded, and a resize was triggered
                if(s.photostovisThmHeight<=0 || s.photostovisThmWidth<=0)
                    _sizeImg(i,true);
            }
            console.assert(r);
            console.assert(rOther);

            console.log("showImg: photostovisI="+s.photostovisI);

            //hide the currently showing set of images, if any
            _hideShowing();

            //set vars
            showingImg=cPicCacheIndex;

            //show/hide things
            rOther.style.display='none';

            if(s.photostovisStatus&statusFlags.FlagMediaLoaded){
                _hideSpinner();
                picWatchStartTime=Date.now();
            } else {
                _showSpinner();
                thmbWatchStartTime=Date.now();
            }
            //check if we have the right infobox showing
            infobox=p.children[2];
            if(infobox && infobox.children.length>0){
                if(showInfo && !s.photostovisInfoboxShown){
                    //we should immediately show the infobox
                    infobox.children[0].style.display="none";
                    infobox.style.width=null;
                    infobox.style.height=null;
                    console.log("Immediately show infobox");
                    if(s.photostovisStatus&statusFlags.FlagMediaLoaded){
                        r.style.top=s.photostovisImgTop0+"px";
                        r.style.left=s.photostovisImgLeft0+"px";
                    } else {
                        r.style.top=s.photostovisThmTop0+"px";
                        r.style.left=s.photostovisThmLeft0+"px";
                    }
                    
                    
            
                }
                if(!showInfo && s.photostovisInfoboxShown){
                    //we should immediately hide the infobox
                    photomapDiv.style.display='';
                    infobox.children[0].style.display=null;
                    infobox.style.width="34px";
                    infobox.style.height="34px";
                    console.log("Immediately hide infobox");
                    if(s.photostovisStatus&statusFlags.FlagMediaLoaded){
                        r.style.top=s.photostovisImgTop+"px";
                        r.style.left=s.photostovisImgLeft+"px";
                    } else {
                        r.style.top=s.photostovisThmTop+"px";
                        r.style.left=s.photostovisThmLeft+"px";
                    }
                }
                
                //map
                if(showInfo){
                    c=picsInAlbum[cPicAlbumIndex];
                    if(typeof(c.lat)!=='undefined' && typeof(google)!=='undefined'){
                        console.assert(typeof(c.lng)!=='undefined');
                        console.log("We have GPS pos: lat="+(c.lat/1000000)+", lng="+c.lng/1000000);
                        if(!map){
                            mapOptions={
                                center: {lat:c.lat/1000000, lng:c.lng/1000000},
                                zoom: 15
                            };
                            map=new google.maps.Map(photomapDiv,mapOptions);
                            photoMarker=new google.maps.Marker({map: map});
                        }
                        //display the photomap
                        photomapDiv.style.display='block';
                        google.maps.event.trigger(map,'resize');
                        //center the map
                        photoPos=new google.maps.LatLng(c.lat/1000000,c.lng/1000000);
                        map.setCenter(photoPos);
                        photoMarker.setPosition(photoPos);
                    } else photomapDiv.style.display='';
                } else photomapDiv.style.display='';
                console.log("Here infobox should be right. infobox clientWidth: "+infobox.clientWidth);
            }
            r.style.display=null;//unhide the picture
            p.style.display=null;//unhide the "master" element
            
            

            if(callback)
                setTimeout(callback,0);

        },
        showVideo:function(i,callback){
            console.assert(i>=0);
            var p,s;

            p=imgDiv.children[i];
            s=mediaShadow[i];
            
            
            //check if we have something to show
            if(!(s.photostovisStatus&statusFlags.FlagMediaLoaded)){
                //nothing to show yet
                console.log("showVideo: nothing to show, yet.");
                _showSpinner();
            } else _hideSpinner();
            console.assert(cPicCacheIndex>=0);

            console.log("showVideo: photostovisI="+s.photostovisI);

            //hide the currently showing set of images, if any
            _hideShowing();

            //set vars
            showingImg=cPicCacheIndex;

            p.style.display=null;//unhide it

            if(callback)
                setTimeout(callback,0);

        },
        getOut:function(){
            _hideShowing();
            _hideSpinner();
            //hide the map
            photomapDiv.style.display='';
            cPicAlbumIndex=-1;
            PH.path[PH.path.length-1].index=-1;
            PH.inPictureMode=false;
            
            //exit full screeen, then continue
            setTimeout(function(){
                PH.exitFullScreen();
                //hide the picture mode div
                elm('imgdiv').style.display='';
                elm('fullscreendiv').style.display='';
                //do we have the same width on exit as on entry?
                if(widthOnEntry!==document.body.clientWidth){
                    //no, we don't. We need to redisplay the album
                    PH.computeThumbnailStrip();
                    PH.displayAlbum(true); //"true" preserves the position
                } else {
                    //display the album, if needed
                    if(typeof(PH.path[PH.path.length-1].forceDisplay)==='boolean' && PH.path[PH.path.length-1].forceDisplay){
                        delete PH.path[PH.path.length-1].forceDisplay;
                        PH.displayAlbum();
                    } else if(PH.loadingThumbnailsStartTime){
                        //if non-zero it means that thumbnails did not finish loading
                        PH.loadingThumbnails=[];
                        PH.skipInvisible=true;
                        PH.loadingThumbnailsStartTime=Date.now();
                        PH.currentScrollTop=elm('cntnt').scrollTop;
                        PH.loadThumbnails();
                    }
                }
            },100);
            //TODO: perhaps is a good idea to remove all elements when we get out. Or perhaps not, because some of them may be reused
        },
        showNext:function(){
            if(cPicAlbumIndex<0)return;
            var timeNow=Date.now();
            var picWatchTime=-1,thmbWatchTime=-1;
            if(picWatchStartTime)picWatchTime=timeNow-picWatchStartTime;
            if(thmbWatchStartTime){
                if(picWatchStartTime)thmbWatchTime=picWatchStartTime-thmbWatchStartTime;
                else thmbWatchTime=timeNow-thmbWatchStartTime; //the user watched the thumbnail all the time (picture was not loading)
            }
            if(showingImg>=0)
                PH.sendWebsocketMessage("watchedID="+mediaShadow[showingImg].photostovisID+" picWT="+picWatchTime+" thmbWT="+thmbWatchTime);
            picWatchStartTime=thmbWatchStartTime=null;
            direction=1;
            PH.path[PH.path.length-1].index=_getNextIndex(cPicAlbumIndex); //returned result can be -1
            PH.setHash();
        },
        showPrev:function(){
            if(cPicAlbumIndex<0)return;
            var timeNow=Date.now();
            var picWatchTime=-1,thmbWatchTime=-1;
            if(picWatchStartTime)picWatchTime=timeNow-picWatchStartTime;
            if(thmbWatchStartTime){
                if(picWatchStartTime)thmbWatchTime=picWatchStartTime-thmbWatchStartTime;
                else thmbWatchTime=timeNow-thmbWatchStartTime; //the user watched the thumbnail all the time (picture was not loading)
            }
            if(showingImg>=0)
                PH.sendWebsocketMessage("watchedID="+mediaShadow[showingImg].photostovisID+" picWT="+picWatchTime+" thmbWT="+thmbWatchTime);
            picWatchStartTime=thmbWatchStartTime=null;
            direction=-1;
            PH.path[PH.path.length-1].index=_getPrevIndex(cPicAlbumIndex); //returned result can be -1
            PH.setHash();
        },
        getPathStr:function(){
            return pathStr;
        },
        currentIsVideo:function(){
            if(cPicAlbumIndex>=0 && (picsInAlbum[cPicAlbumIndex].fl&PH.server.albumFlags.FlagIsVideo))
                return true;
            return false;
        },
        toggleInfobox:function(x,y){
            if(cPicCacheIndex<0)return false; //no toggle
            var p=imgDiv.children[cPicCacheIndex],s=mediaShadow[cPicCacheIndex],r,c;
            if(p.children.length<3)return false; //no toggle
            var infobox=p.children[2];
            var rect=infobox.getBoundingClientRect();
            var btm,rgt;
            //console.log(rect.top, rect.right, rect.bottom, rect.left);
            if(x<rect.left || x>rect.right || y<rect.top || y>rect.bottom)
                return false; //click is outside the box
            
            //if here, we are inside the box
            if(showInfo){
                //hide the infobox
                showInfo=false;
                localStorage.showPicInfo=false;
                PH.sendPreferencesToPhonet();
                photomapDiv.style.display='';
                
                //prepare the transition
                infobox.style.transition="bottom 0.5s ease-out, right 0.5s ease-out";
                btm=5+34-infobox.clientHeight;
                rgt=5+34-infobox.clientWidth;
                //apply changes
                infobox.style.bottom=btm+"px";
                infobox.style.right=rgt+"px";
                s.photostovisInfoboxShown=false;
                
                r=p.children[0];
                r.style.transition="top 0.5s ease-out, left 0.5s ease-out";
                r.style.top=s.photostovisThmTop+"px";
                r.style.left=s.photostovisThmLeft+"px";
                r=p.children[1];
                r.style.transition="top 0.5s ease-out, left 0.5s ease-out";
                r.style.top=s.photostovisImgTop+"px";
                r.style.left=s.photostovisImgLeft+"px";
                
                setTimeout(function(){
                    infobox.children[0].style.display=null;
                    infobox.style.width="34px";
                    infobox.style.height="34px";
                    infobox.style.bottom="5px";
                    infobox.style.right="5px";
                    infobox.style.transition=null;
                    p.children[0].style.transition=null;
                    p.children[1].style.transition=null;
                },500);
            } else {
                //show the infobox
                showInfo=true;
                localStorage.showPicInfo=true;
                PH.sendPreferencesToPhonet();
                //move the infobox outside of our screen
                infobox.style.transition=null;
                infobox.style.right="-400px";
                //"show" the infobox
                infobox.children[0].style.display="none";
                infobox.style.width=null;
                infobox.style.height=null;
                //compute the starting right and bottom values
                btm=5+34-infobox.clientHeight;
                rgt=5+34-infobox.clientWidth;
                infobox.style.right=rgt+"px";
                infobox.style.bottom=btm+"px";
                
                setTimeout(function(){
                    //prepare the transition
                    infobox.style.transition="bottom 0.5s ease-out, right 0.5s ease-out";
                    //apply changes
                    infobox.style.bottom="5px";
                    infobox.style.right="5px";
                    s.photostovisInfoboxShown=true;
                    
                    r=p.children[0];
                    r.style.transition="top 0.5s ease-out, left 0.5s ease-out";
                    r.style.top=s.photostovisThmTop0+"px";
                    r.style.left=s.photostovisThmLeft0+"px";
                    r=p.children[1];
                    r.style.transition="top 0.5s ease-out, left 0.5s ease-out";
                    r.style.top=s.photostovisImgTop0+"px";
                    r.style.left=s.photostovisImgLeft0+"px";
                   
                    setTimeout(function(){
                        var mapOptions,photoPos;
                        infobox.style.transition=null;
                        p.children[0].style.transition=null;
                        p.children[1].style.transition=null;
                        //do we show a map?
                        c=picsInAlbum[cPicAlbumIndex]; 
                        if(typeof(c.lat)!=='undefined'){
                            console.assert(typeof(c.lng)!=='undefined');
                            console.log("We have GPS pos: lat="+(c.lat/1000000)+", lng="+c.lng/1000000);
                            if(!map){
                                mapOptions={
                                    center: {lat:c.lat/1000000, lng:c.lng/1000000},
                                    zoom: 15
                                };
                                map=new google.maps.Map(photomapDiv,mapOptions);
                                photoMarker=new google.maps.Marker({map: map});
                            }
                            //display the photomap
                            photomapDiv.style.display='block';
                            google.maps.event.trigger(map,'resize');
                            //center the map
                            photoPos=new google.maps.LatLng(c.lat/1000000,c.lng/1000000);
                            map.setCenter(photoPos);
                            photoMarker.setPosition(photoPos);
                        } else photomapDiv.style.display='';
                        
                    },550);
                },0);

            }
            return true;
        }
    };//returned object    
})();
